PKG-CREATE(8)

NAME
pkg create - a utility for creating software package distributions

SYNOPSIS
pkg create [-n] [-f format] [-o outdir] [-p plist] [-r rootdir] -m manifestdir
pkg create [-gnxX] [-f format] [-o outdir] [-r rootdir] pkg-name ...
pkg create [-n] [-f format] [-o outdir] [-r rootdir] -a

DESCRIPTION
pkg create is used to create packages from binaries or other files installed on your computer. Package tarballs can created from the files of a previously installed package using metadata from the local package database. Any number of packages may be created in one invocation of this style.

Alternatively, a single package can be created from an arbitrary selection of files on your system, but this requires a manifestdir and optionally plist to be supplied. The package name will be derived from the +MANIFEST file which must be contained within the manifestdir.

Packages thus created can be distributed and subsequently installed on other machines using the pkg add command.

OPTIONS
The following options are supported by pkg create:

-a  Create package tarballs from all packages installed on your system. This option is incompatible with the -g, -x, -X or -m manifestdir options.

-g  Interpret pkg-name as a shell glob pattern and create package only for installed binaries whose name match this pattern. This option is incompatible with the -a, -x, -X or -m manifestdir options.

-x  Like -g, but interpret pkg-name as a regular expression. This option is incompatible with the -a, -g, -X or -m manifestdir options.

-X  Like -g, but interpret pkg-name as an extended regular expression. This option is incompatible with the -a, -g, -x or -m manifestdir options.

-f format
    Set format as the package output format. It can be one of txz, tbz, tgz or tar which are currently the only supported format. If an invalid or no format is specified txz is assumed.

-m manifestdir
    Specify the directory containing the package manifest, +MANIFEST and optionally two other files; one containing a message to be displayed on package installation, +DISPLAY and the other containing an mtree specification, +MTREE_DIRS, for the directory tree the package will use. See mtree(5) for the format of the mtree file. If specified, only a single package will be created. Neither +DISPLAY nor +MTREE_DIRS are required; the +MANIFEST file can contain all the required information needed to build a package. This option is incompatible with the -a, -g, -x or -X options.

-n  Do not overwrite already existing packages

-o outdir
    Set outdir as the output directory. If this option is not given, all created packages will be saved in the current directory.

-p plist
    Specify some package metadata using the legacy plist format from pkg_add(1), commonly found in pkg-plist files in the ports tree. Metadata from the plist file, if specified, will take precedence over any equivalents from the manifestdir. Only has any effect when used with manifestdir.

-r rootdir
    rootdir specifies the top-level directory to be treated as the root of the filesystem heirarchy containing the package files. File paths in generated packages will be relative to rootdir. This allows a package to be generated from content offset from its intended final location, which allows a package building without disturbing similar content already on the system. If unspecified, the default is effectively /, the actual root directory.

MANIFEST FILE DETAILS

name pkg-name
    This entry sets the package's name to pkg-name. Among other things, this name is used - with the version and the origin of the concerned package - to identify a dependency.

version pkg-version
    This entry sets the package's version to pkg-version.

origin pkg-origin
    This entry sets the package's origin to pkg-origin. This is a string of the form category/port-dir which designate the port this package was built from.

comment comment-string
    comment-string is a one-line description of this package. It is the equivalent of the COMMENT variable for a port, not a way to put comments in a +MANIFEST file.

arch cpu-type
    The architecture of the machine the package was built on. cpu-type takes values like x86, amd64...

osversion os-version
    Version of the OS used to build the package.

www url
    The software's official website.

maintainer mail-address
    The maintainer's mail address.

prefix path-prefix
    The path where the files contained in this package are installed (usually /usr/local).

flatsize size
    The size that the files contained in this package will occupy on your system once uncompressed. This value does not take into account files stored in the package database.

dep dep-name dep-origin dep-version
    Declare a dependency on the package which name, origin and version match dep-name, dep-origin and dep-version respectively.

conflict pkg-glob
    Flag this package as incompatible with the one designated by pkg-glob. Conflicting packages cannot be installed on the same system as they may contain references to the sames files.

option option-name option-value
    Set the option option-name to the value option-value.

file sha256-hash path
    file entries list files included in the package. If the file is a regular one, such an entry contains its sha256 digest along with its path. If a packaged file is a link, you must use this entry's other form, as described below.

file - path
    Same as above but for file links. The sha256 hash is replaced with a - (dash).

dir path
    Mimics the file entry but for directories.

ENVIRONMENT
The following environment variables affect the execution of pkg create. See pkg.conf(5) for further description.

PKG_DBDIR

PLIST_KEYWORDS_DIR

PORTSDIR

FILES
See pkg.conf(5).

EXAMPLES
Create package files for installed packages:
    % pkg create -a -o /usr/ports/packages/All

Create package file for pkg:
    % pkg create -o /usr/ports/packages/All pkg

SEE ALSO
pkg(8), pkg-add(8), pkg-audit(8), pkg-autoremove(8), pkg-backup(8), pkg-check(8), pkg-clean(8), pkg-delete(8), pkg-fetch(8), pkg-info(8), pkg-install(8), pkg-query(8), pkg-register(8), pkg-repo(8), pkg-rquery(8), pkg-search(8), pkg-set(8), pkg-shell(8), pkg-shlib(8), pkg-stats(8), pkg-update(8), pkg-updating(8), pkg-upgrade(8), pkg-version(8), pkg-which(8), pkg.conf(5)